//+------------------------------------------------------------------+
//|                                                  DalesLevels.mq4 |
//|                               Copyright 2016, u5ername@seznam.cz |
//|                     www.forexfactory.com/showthread.php?t=608433 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, u5ername@seznam.cz"
#property link      "https://www.forexfactory.com/showthread.php?t=608433"
#property version   "1.00"
#property strict
#property indicator_chart_window
//+------------------------------------------------------------------+
//| Inicializace indiktoru:                                         |
//| Veker zobrazovan hodnoty se do grafu vykresl v prbhu       |
//| inicializace indiktoru. Indiktor byl pouit namsto skriptu,   |
//| abych mohl pi odpojen indiktoru pohodln vymazat vechny      |
//| grafick prvky.                                                  |
//| 
//| Edited by Dietcoke 2017/01/10
//| Add
//+------------------------------------------------------------------+
input int TP = 10;
input int SL = 12;
input bool ShowTPSL = false;
input string MyLevels = "MARK";
double tp, sl;


int OnInit()
{
//--- deklarace promnnch -------------------------------------------
   int Handle;                         // File descriptor
   string File_Name="daleslevels.csv", // Name of the file
          Obj_Name,                    // Name of the object
          Str_DtTm,                    // Date and time of the event (etzec)
          Instrument,                  // Name of the currency
          Str_Level,                   // Cenov hladina (etzec)
          Text,                        // Textov popis objednvky
          Komentar,                    // Text kontrolnho komente
          Datum_YYMMDD;
   datetime Dat_DtTm;                  // Date and time of the event (date)
   double Level;                       // Cenov hladina (slo)

//--------------------------------------------------------------------

   Handle=FileOpen(File_Name,FILE_CSV|FILE_READ,";"); // File opening
   if(Handle<0)                                       // File opening fails
   {
      if(GetLastError()==4103)                        // If the file does not exist,..
         Alert("No file named ",File_Name);           //.. inform trader
      else                                            // If any other error occurs..
         Alert("Error while opening file ",File_Name);//..this message
      PlaySound("bzrrr.wav");                         // Sound accompaniment
      return(INIT_FAILED);                            // Exit      
   }
//--------------------------------------------------------------------
   while(FileIsEnding(Handle)==false)           // While the file pointer..
   {                                            // ..is not at the end of the file
      //--------------------------------------------------------------
      Str_DtTm    = FileReadString(Handle);     // Date and time of the event (date)
      Instrument  = FileReadString(Handle);     // Text of event description
      Str_Level   = FileReadString(Handle);     // Text of event description
      Text        = FileReadString(Handle);     // Text of event description
      
      //Komentar = Komentar + "Naten hodnoty: "+ Str_DtTm + " "+ Instrument +" "+ Str_Level +" "+ Text + "\n";
      //--------------------------------------------------------------
      Dat_DtTm     = StrToTime(Str_DtTm);                   // Transformation of data type
      Level        = StrToDouble(Str_Level);                // Pevod promnn na selnou hodnotu
      Datum_YYMMDD = TimeToStr(Dat_DtTm,TIME_DATE);         // Pevedu datum na formt yymmdd...
      Datum_YYMMDD = StringSubstr(Datum_YYMMDD,  2, 2)      // yy
                   + StringSubstr(Datum_YYMMDD,  5, 2)      // mm
                   + StringSubstr(Datum_YYMMDD,  8, 2);     // dd hh
   
   tp = TP *Point*10;
   sl = SL *Point*10;
       Comment("tp=",tp," sl=",sl, "point= ",Point);

 
      //Komentar = Komentar + "Dat_DtTm " + Dat_DtTm + " Str_DtTm " + Str_DtTm + " Datum_YYMMDD " + Datum_YYMMDD + "\n";
      if(StringFind(Symbol(), Instrument, 0)!=-1)     // And for the events of our..
      {                              // .. symbol..
         //Komentar = Komentar + "... vyhovuje.\n";
         VykresleniObjednavky(Datum_YYMMDD,Str_Level,Text,Dat_DtTm);
      }
      //Comment(Komentar);
   }
  //int DigitsM
   //if (Digits == 5) DigitsM = 4;
	//else if (Digits == 3) DigitsM = 2;
	//else if (Digits == 1) DigitsM = 0;
	//else DigitsM = Digits;
//--------------------------------------------------------------------
   FileClose( Handle );                // Close file
   PlaySound("transform.wav");         // Sound accompaniment
   WindowRedraw();                     // Redraw object
   return(INIT_SUCCEEDED);             // Exit
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   ObjectsDeleteAll("DL_",0, OBJ_TREND); // delete all trendlines from main chart with prefix...   
   return;
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
//---
   
//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Funkce - Vykreslen objednvky jako trendovka                    |
//+------------------------------------------------------------------+
void VykresleniObjednavky(string Datum_YYMMDD, string Str_Level, string Text, datetime Dat_DtTm)
{
   string Obj_Name;                    // Nzev vykreslovanho objektu
   int chart_ID;                       // Aktuln graf
   double Level;                       // Cenov hladina (slo)
   color BarvaLinie;                   // Barva vykreslovan linky

   Level        = StrToDouble(Str_Level);                // Pevod promnn na selnou hodnotu
	bool v = StringToUpper(Text);
   chart_ID=0;                                           // Aktuln graf

   Obj_Name="DL_"+Datum_YYMMDD+"_"+Str_Level+"_"+StringSubstr(Text,0,35);

   if(StringFind(Text, "S", 0)!=-1)
   {
      if(StringFind(Text, MyLevels, 0)!=-1) BarvaLinie = clrOrange;
      else BarvaLinie = clrHotPink;
 
      if(ShowTPSL) {
      	PlotTL(Obj_Name+"_tp",Dat_DtTm,Dat_DtTm+24*3600,Level-tp ,Level-tp, clrLightGreen,1);
      	PlotTL(Obj_Name+"_sl",Dat_DtTm,Dat_DtTm+24*3600,Level+sl ,Level+sl, clrRed,1);
      	}
   }
   else
   {
      if(StringFind(Text, MyLevels, 0)!=-1) BarvaLinie = clrCornflowerBlue;
      else BarvaLinie = clrPaleGreen;
      
      if(ShowTPSL) {
      	PlotTL(Obj_Name+"_tp",Dat_DtTm,Dat_DtTm+24*3600,Level+tp ,Level+tp, clrLightGreen,1);
      	PlotTL(Obj_Name+"_sl",Dat_DtTm,Dat_DtTm+24*3600,Level-sl ,Level-sl, clrRed,1);
      	}
  }
   // ====================== vykreslen trendline ==============
   
   //--- create a trend line by the given coordinates
   if(!ObjectCreate(chart_ID,Obj_Name,OBJ_TREND,0,Dat_DtTm,Level,Dat_DtTm+24*3600,Level))
   {
      Print(__FUNCTION__, ": failed to create a trend line! Error code = ",GetLastError());
      return;
   }
   //--- set line color
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_COLOR,BarvaLinie);
   //--- set line display style (STYLE_DASH, STYLE_DASH
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_STYLE,STYLE_SOLID);
   //--- set line width
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_WIDTH,3);
   //--- display in the foreground (false) or background (true)
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_BACK,true);
   //--- enable (true) or disable (false) the mode of moving the line by mouse
   //--- when creating a graphical object using ObjectCreate function, the object cannot be
   //--- highlighted and moved by default. Inside this method, selection parameter
   //--- is true by default making it possible to highlight and move the object
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_SELECTABLE,true);
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_SELECTED,false);
   //--- enable (true) or disable (false) the mode of continuation of the line's display to the right
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_RAY_RIGHT,false);
   //--- hide (true) or display (false) graphical object name in the object list
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_HIDDEN,false);
   //--- set the priority for receiving the event of a mouse click in the chart
   ObjectSetInteger(chart_ID,Obj_Name,OBJPROP_ZORDER,0);
   //--- define text for object Label 
   ObjectSetString(chart_ID,Obj_Name,OBJPROP_TEXT,Str_Level+" - "+StringSubstr(Text,0,50));
   
   return; 
}

bool PlotTL(string name, datetime dt1=0, datetime dt2=0, double prc1=0,  double prc2=0, color clr=0, int width=1, int style=STYLE_DOT, bool ray=false, bool bg=false, int vis=0,int win=0)  {
//+------------------------------------------------------------------+
  if (StringLen(name)<1 || dt1<=0 || prc1<=0)   return(false);

  win = MathMax(win,0);
  if (dt2<=0)     dt2  = dt1;
  if (prc2<=0)    prc2 = prc1;
//  if (clr<0)      clr  = White;
  width = MathMax(width,1);
  if (ObjectFind(name) < 0)
    ObjectCreate(name,OBJ_TREND,win,dt1,prc1,dt2,prc2);
  ObjectSet(name,OBJPROP_COLOR,clr);
  ObjectSet(name,OBJPROP_WIDTH,width);
  ObjectSet(name,OBJPROP_STYLE,style);
  ObjectSet(name,OBJPROP_RAY,ray);
  ObjectSet(name,OBJPROP_BACK,bg);
  ObjectSet(name,OBJPROP_TIMEFRAMES,vis);
  return(true);
}
